//+------------------------------------------------------------------+
//|                                                  RWB_ENV_IND.mq4 |
//|                              Copyright  2006, Randall W. Bowles |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Randall W. Bowles"
#property link      "http://www.metaquotes.net"
 
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 White
 
extern int TF = PERIOD_M15;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   
   string short_name = "Randys ENV Indicator";
   IndicatorShortName(short_name);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//---- check for possible errors
   if (counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if (counted_bars>0) counted_bars--;
   
   int    pos=Bars-counted_bars;
   int bs = 0; 
 while(pos>=0)
 {
    double envhigh, envlow;
  bs = iBarShift(NULL, TF, Time[pos]);
  envhigh = iEnvelopes(NULL, TF, 1,MODE_SMA,0,PRICE_CLOSE,0.1,MODE_UPPER,bs);
  envlow = iEnvelopes(NULL, TF, 1,MODE_SMA,0,PRICE_CLOSE,0.1,MODE_LOWER,bs);
   
   //iCustom(NULL,PERIOD_M15,iEnvelopes,1,1,simple,close,.1,2,0)
   ExtMapBuffer1[pos] = envhigh;
   ExtMapBuffer2[pos] = envlow;
   pos--;
 }
 
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+